/*
* Vinyl widget:
* Name: Masking Widget
* Developer: Clay Chaffins
* Date: 10/11/2018
*/

function generateUUID() {
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = (d + Math.random()*16)%16 | 0;
        d = Math.floor(d/16);
        return (c=='x' ? r : (r&0x3|0x8)).toString(16);
    });
    return uuid;
};


//Start of JS addition

function formatNumber(n) {
  // format number 1000000 to 1,234,567
  return n.replace(/\D/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",")
}

function formatCurrency(input, blur) {
  // appends $ to value, validates decimal side
  // and puts cursor back in right position.

  // get input value
  var input_val = input.val();

  // don't validate empty input
  if (input_val === "") { return; }

  // original length
  var original_len = input_val.length;

  // initial caret position
  var caret_pos = input.prop("selectionStart");

  // check for decimal
  if (input_val.indexOf(".") >= 0) {

    // get position of first decimal
    // this prevents multiple decimals from
    // being entered
    var decimal_pos = input_val.indexOf(".");

    // split number by decimal point
    var left_side = input_val.substring(0, decimal_pos);
    var right_side = input_val.substring(decimal_pos);

    // add commas to left side of number
    left_side = formatNumber(left_side);

    // validate right side
    right_side = formatNumber(right_side);

    // On blur make sure 2 numbers after decimal
    if (blur === "blur") {
      right_side += "00";
    }

    // Limit decimal to only 2 digits
    right_side = right_side.substring(0, 2);

    // join number by .
    input_val = "$" + left_side + "." + right_side;

  } else {
    // no decimal entered
    // add commas to number
    // remove all non-digits
    input_val = formatNumber(input_val);
    input_val = "$" + input_val;

    // final formatting
    if (blur === "blur") {
      input_val += ".00";
    }
  }

  // send updated string to input
  input.val(input_val);

  // put caret back in the right position
  var updated_len = input_val.length;
  caret_pos = updated_len - original_len + caret_pos;
  input[0].setSelectionRange(caret_pos, caret_pos);
}

// END OF JS

define(function () {
  var install = function (holderElement, context) {

    // storing current values of the row and cell
    var cell = context.getCell();
    var row = context.getRow();

    var currentUUID = generateUUID();

    console.log(cell.value);
    if(cell.value == null) {
      console.log("this is null");
      var appendStr = "";
    } else {
      console.log("this is NOT null");
      var appendStr = cell.value;
    }

    var divStr = "<input id='" + currentUUID + "' " + " type='text' name='currency-field' pattern='^\$\d{1,3}(,\d{3})*(\.\d+)?$' value='$" + appendStr + "'" + " data-type='currency' />";
    console.log(divStr);
    $(holderElement).append(divStr);


    var currentWidget = document.getElementById(currentUUID);
    console.log(currentWidget);

    // set the mask to the value we currently have in the cell
    //currentWidget.setAttribute("placeholder", cell.value);

    // if the textbox is not RO and edit button is pressed

    // if the user typed in something in the textbox or copy and pasted something
    // into the text box or modified the textbox in any way
    currentWidget.oninput = function()
    {
        // assign the new value in the cell to our cell in vinyl
        var NoComma = currentWidget.value.replace(",", "");
        var NoComma2 = NoComma.replace("$", "");
		if (NoComma2)
		{
        		cell.value = NoComma2;
		}
    else
    {
      console.log("There is nothing!");
      cell.value = null;
      console.log(cell.value);
    }
    console.log("NoComma2");
    console.log(NoComma2);
    };

//CODE for JS goes here: https://codepen.io/CovertClay/pen/PMZYBP

$("input[data-type='currency']").on({
    keyup: function() {
      formatCurrency($(this));
    },
    blur: function() {
      formatCurrency($(this), "blur");
    }
});

  };


  var uninstall = function (holderElement, context) {
  };

  return {
    callbacks: {
      events: {
        install: install,
        uninstall: uninstall
      }
    }
  };
});
